VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmMain 
   Caption         =   "8RGBpwmblinkenlights"
   ClientHeight    =   4365
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   12630
   LinkTopic       =   "Form1"
   ScaleHeight     =   4365
   ScaleWidth      =   12630
   StartUpPosition =   3  'Windows Default
   Begin MSCommLib.MSComm MSComm1 
      Left            =   4740
      Top             =   1920
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.TextBox txtPath 
      Height          =   315
      Left            =   60
      TabIndex        =   2
      Top             =   60
      Width           =   11475
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load File"
      Height          =   315
      Left            =   11580
      TabIndex        =   1
      Top             =   60
      Width           =   975
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   540
      Top             =   840
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Timer timerDisplay 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   4740
      Top             =   540
   End
   Begin VB.TextBox txtInfo 
      Height          =   3855
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "Form1.frx":0000
      Top             =   420
      Width           =   12555
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim safeUnload As Boolean
Dim fullFile As String
Dim frameArray() As String
Dim currentFrame As Integer

Private Sub Form_Load()
    MSComm1.CommPort = 1
    MSComm1.Settings = "19200,N,8,1"
    MSComm1.InputLen = 0
    MSComm1.RThreshold = 3
    MSComm1.PortOpen = True
    'MSComm1.Output = Chr(0)
    'MSComm1.Output = Chr(0)
    'MSComm1.Output = Chr(0)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'MSComm1.Output = Chr(0)
    'MSComm1.Output = Chr(0)
    'MSComm1.Output = Chr(0)
    MSComm1.PortOpen = False
End Sub

Private Sub cmdLoad_Click()
    CommonDialog1.ShowOpen
    txtPath.Text = CommonDialog1.FileName
    loadMovieFile (txtPath.Text)
End Sub

Private Function loadMovieFile(thePath As String)
    Dim theLine As Integer
    Dim tempLine As String
    Dim tempFrame As String
    
    timerDisplay.Enabled = False
    
    If FileExists(CStr(thePath)) <> "False" Then
        
        FileLength = FileLen(CStr(thePath))
        Open (CStr(thePath)) For Input As #1
            fullFile = Input(FileLength, #1)
        Close 1
        txtInfo.Text = ""
        fullFile = Replace(fullFile, Chr(13), "")
        
        ReDim frameArray(0)
        For theLine = 1 To CountFields(fullFile, Chr(10))
            tempLine = NthField(fullFile, Chr(10), theLine)
            If Left(tempLine, 1) = "#" Then txtInfo.Text = txtInfo.Text & tempLine & vbCrLf
            If Left(tempLine, 1) = "@" Then
                ReDim Preserve frameArray(UBound(frameArray) + 1)
                tempFrame = NthField(fullFile, Chr(10), theLine) & Chr(8)
                tempFrame = tempFrame & Replace(NthField(fullFile, Chr(10), theLine + 1), ".", "") & Chr(8)
                tempFrame = tempFrame & Replace(NthField(fullFile, Chr(10), theLine + 2), ".", "") & Chr(8)
                tempFrame = tempFrame & Replace(NthField(fullFile, Chr(10), theLine + 3), ".", "") & Chr(8)
                frameArray(UBound(frameArray)) = tempFrame
                theLine = theLine + 4
                txtInfo.Text = txtInfo.Text & tempFrame & vbCrLf
            End If
        Next
    End If
    
    currentFrame = 1
    timerDisplay.Enabled = True
End Function

Private Sub timerDisplay_Timer()
    displayFrame (currentFrame)
    If currentFrame = UBound(frameArray) Then currentFrame = 0
    currentFrame = currentFrame + 1
End Sub

Private Function displayFrame(frameNumber As Integer)
    Dim theFrame As String
    
    MSComm1.Output = Chr(1)
    
    timerDisplay.Interval = Int(NthField(NthField(frameArray(frameNumber), Chr(8), 1), "@", 2))
    theFrame = NthField(frameArray(frameNumber), Chr(8), 2)
    theFrame = theFrame & NthField(frameArray(frameNumber), Chr(8), 3)
    theFrame = theFrame & NthField(frameArray(frameNumber), Chr(8), 4)
    For x = 0 To 11
        MSComm1.Output = Chr(conv_bin_dec(Mid(theFrame, x * 8 + 1, 8)))
        'MsgBox Mid(theFrame, x * 8 + 1, 8)
    Next
End Function

Public Function FileExists(strFile) As String
    On Error Resume Next
    FileExists = Dir(strFile) <> ""
End Function

Private Function NthField(expression As String, separator As String, fieldNum As Integer) As String
    Dim fields() As String
    fields = Split(expression, separator, , vbTextCompare)
    NthField = fields(fieldNum - 1)
End Function

Private Function CountFields(expression As String, separator As String) As Long
    Dim fields() As String
    fields = Split(expression, separator, , vbTextCompare)
    CountFields = UBound(fields) + 1
End Function

Function conv_bin_dec(bite) As Integer
    Y = Len(bite) - 1
    For x = 1 To Len(bite)
        conv_bin_dec = conv_bin_dec + ((2 ^ Y)) * (Mid$(bite, x, 1))
        Y = Y - 1
    Next x
End Function
